// Aufruf Lokal | Vienna 03.08.2008
//
// Radio ber Aktionsmen ein- und ausschalten
//
// 1. Aufruf schaltet Radio ein. Nchster Aufruf schaltet aus. usw.
//
// Aufruf in der Initialisierung eines Objekt:  temp = this addAction ["Aktionstext","Dateiname",["Soundname",Soundlnge],-1,false,true,""]
// Beispiel: temp = this addAction ["*** Radio ein- oder ausschalten ***","Sounds\Radio.sqf",["BlackAttack",127],-1,false,true,""]
//
// In der description.ext ist die Klasse fr den Sound einzufgen.


// Lokale Variable
	private ["_o","_s","_l","_r","_t"];


//globale Variable beim ersten Aufruf fr Radio Kontrolle initialisieren.
	if (isNil "ViennasRadio") then {ViennasRadio = false};


// _o: Objekt welches den Sound abgibt
	_o = _this select 0;

// _s: Soundname aus dem Parameter in der Aktion laden
	_s = (_this select 3) select 0;
	
// _l: Lnge des Musikstcks (darf nicht viel krzer sein, sonst berschneidung)
	_l = (_this select 3) select 1;


//Wenn aufrufendes Objekt zerstrt, dann Aktion entfernen
 if (!alive _o) exitWith {player groupChat "---- Radio nicht mehr betriebsbereit! ----"; _o removeAction (_this select 2)};


// Radio einschalten wenn ViennasRadio false und ausschalten wenn ViennasRadio true
///////////////////////////////////////////////////////////////////////////////////

	if (!ViennasRadio) then //Radio erstellen (Radio einschalten)
		{
			ViennasRadio = true;
			// _r: logisches "Radioobjekt"
			_r = "Logic" createVehicle getPos player;
		  // Hauptschleife Sound starten (Wiederholung bis abgeschaltet wird)
			while {ViennasRadio AND alive _o} do
				{
					// Sound starten
					_r say _s;
					// _t: nach Zeitablauf Sound neu starten
					_t = time + _l - 5;
					// Warteschleife bis Soundende und "Radio" dem Objekt _o nachsetzen
					while {_t > time AND ViennasRadio AND alive _o} do 
						{
							_r setPos position _o;
							sleep 0.5
						}
				};
			deleteVehicle _r
	}
else // vorherigen Radioskriptaufruf beenden (Radio ausschalten)
	{
		ViennasRadio = false;
	}
